//client.c
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/un.h>
#include <signal.h>

#define  BUFF_SIZE   1024
#define  FILE_SERVER "/tmp/test_server"

#pragma pack(push, 1)
typedef struct uData {
  int pid;
  int nowLife;
  int betLife;
  int showChance;
  int rank;
} user;
#pragma pack(pop)

static user myData;



void start_signal(int signo) {

  sigset_t sigset, oldset;

  sigfillset(&sigset); //block

  if(sigprocmask(SIG_BLOCK, &sigset, &oldset) < 0) {
    printf("sgprocmask %d error\n", signo);
  }

  if (signo == 10) {
 //   printf("-------------------------------\n| ALL PLAYER READY! GAME START |\n-------------------------------\n");
  } else if(signo == 12) {
    printf("You can't not out in game\n");
  }
}

void * fun_sendData() {
  char * str = malloc(sizeof(char)*100);
  sprintf(str,"%d|@|%d|@|%d|@|%d|@|%d",myData.pid,myData.nowLife,myData.betLife,myData.showChance, myData.rank);
  return str;
}

void splitStruct(char *s1) {

  char *split = strtok(s1,"|@|");
  int n = 0;

  while(split != NULL) {
   
    switch(n) {
      
      case 0: myData.pid = atoi(split); break;
      case 1: myData.nowLife = atoi(split); break;
      case 2: myData.betLife = atoi(split); break;
      case 3: myData.showChance = atoi(split); break;      
      case 4: myData.rank = atoi(split); break;
      case 5: printf("NULL 반환 혹은 ERROR!\n"); break;     
    }
  split = strtok(NULL, "|@|");
  n++;
  }


printf("\n\n-------------------------------\n|     *** 현재 내 진행상황 ***\n|  ID=%d, 남은 생명력=%d\n-------------------------------\n",myData.pid, myData.nowLife);

}


int main( int argc, char **argv) {
  int client_socket;

  struct sigaction mySig;
  struct sockaddr_un  server_addr;

  char buff[BUFF_SIZE+5];
  char sendData[250];
  char s[200];
  char *s_struct;
  char struct_buf[100];    

  mySig.sa_handler = start_signal;
  sigemptyset(&mySig.sa_mask);
  mySig.sa_flags = 0;


  //myData init
  myData.pid = getpid();
  myData.nowLife = 100;
  myData.betLife = 0;
  myData.showChance = 1;
  myData.rank = 0;

  client_socket  = socket( PF_FILE, SOCK_STREAM, 0);
  if( -1 == client_socket) {
    printf( "socket 생성 실패\n");
    exit( 1);
  }

  memset( &server_addr, 0, sizeof(server_addr));
  server_addr.sun_family = AF_UNIX;
  strcpy(server_addr.sun_path, FILE_SERVER);

  if(sigaction(SIGUSR1, &mySig, 0) == -1) {
     perror("can not catch SIGUSER1\n");
  }

  if(-1 == connect(client_socket, (struct sockaddr*)&server_addr, sizeof(server_addr))) {
    printf("Can not find Server. Check Server Process!!!\n");
    exit( 1);
  }

  s_struct = fun_sendData(); //데이터 일렬화
  
  write(client_socket, (void *)s_struct, strlen(s_struct)+1); //접속시 사용자 정보 서버에 저장
  
  pause();    
  
  read (client_socket, buff, BUFF_SIZE); //접속 성공 메시지 반환
  printf("%s\n",buff);

 while(1) {


   // if(myData.nowLife >0) {  
      
      pause(); // 서버 로직 실행 대기
  
      read(client_socket, buff, BUFF_SIZE); //몇턴인지 측정
      if(buff[0] == '#') {
        printf("\n\n\n\n\n\n\n\n\n\n\n%s\n\n",buff);
        exit(0);
      }

      printf ("%s번째 턴 시작합니다.\n",buff); //출력
      buff[0] = '\0'; //초기화

      while (1) {
       
      if(myData.nowLife > 0) {
        printf("How much betting Your Life? ");
        scanf("%d", &myData.betLife);

        if(myData.betLife < 1 || myData.betLife >30) {
          printf("You can betting life between 1 and 30!\n");
        } else {

          if(myData.betLife < myData.nowLife) { 
            myData.nowLife -=myData.betLife;
            printf("bet life = %d\n",myData.betLife);

          } else {
            printf("You Died\n");
            myData.betLife = 0;
            myData.nowLife = 0;

          }
        
            //pause();
            s_struct = fun_sendData(); //구조체 일렬화
            write(client_socket, (void *)s_struct, strlen(s_struct)+1); //구조체 작성
            break;
        }
        while(getchar() != '\n');
      } else {
          myData.nowLife = 0;
          myData.betLife = -30;
          s_struct = fun_sendData();
          write(client_socket, (void *)s_struct, strlen(s_struct)+1);      
          printf("당신은 생명력이 없습니다. 관전해주세요\n");    
          break;
        }
    }
      printf("다른사람들이 배팅하는것을 기다리는 중입니다. 잠시만 기다려주세요.\n");
      
      
      buff[0]='\0';
      
      pause();
      read(client_socket,buff,BUFF_SIZE);
      printf("\n%s",buff);
      
      pause();

      read(client_socket, struct_buf, BUFF_SIZE);
      splitStruct(struct_buf);
      struct_buf[0]= '\0';
      
  }

  return 0;
}
