#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/un.h>
#include <pthread.h>
#include <signal.h>

#define  BUFF_SIZE   1024
#define  FILE_SERVER "/tmp/test_server"
#define  ALL_PLAYER_READY 10
#define  DOUBLE_FIRST 5
#define  DOUBLE_SECOND 2
#define  DOUBLE_THIRD 3
#define  NONE_SECOND 1
#define  NOT_EXCEPTION 0

#pragma pack(push, 1)
typedef struct uData {
  int pid;
  int nowLife;
  int betLife;
  int showChance;
  int rank;
} user;

typedef struct clientNetInfo {
  int num;
  int socket;
  int addr_size;
  int addr;
} sock;
#pragma pack(pop)

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t child_mutex = PTHREAD_MUTEX_INITIALIZER;
static int   server_socket;
static int   option;
static int   pCount = 0;
static int   er_or = 0;
static struct sockaddr_un   server_addr; 

static char   buff_rcv[BUFF_SIZE+5];
static char   buff_snd[BUFF_SIZE+5];
static char   struct_buf[100];

static user client[4];
static sock net[4];

static int retval = 1000;

static char *s_struct;

static int returnResult = NOT_EXCEPTION;
static char resultGameString[BUFF_SIZE];
static char readyNextTurnString[BUFF_SIZE];
static char all_status[BUFF_SIZE];
static int revSumLife = 0;


static int reRank[4];

static  pid_t pid;

void rev_signal(int signo) {
  sigset_t sigset, oldset;

  sigfillset(&sigset);

  if(sigprocmask(SIG_BLOCK, &sigset, &oldset) <0) {
    perror("sigprocmask ERROR!\n");
  }

  if (signo == 10) {
    printf("GET SIGINT1@@@@@@@@@@@@@@-\n");
  } else if(signo == 12) {
    printf("You can't not out in game\n");
  }
}

void * fun_sendData(int i) {
  char * str = malloc(sizeof(char)*100);
  sprintf(str,"%d|@|%d|@|%d|@|%d|@|%d",client[i].pid, client[i].nowLife, client[i].betLife, client[i].showChance, client[i].rank);
  return str;
}

void splitStruct(char *s1, int i) {

  char *split = strtok(s1,"|@|");
  int n = 0;

  while(split != NULL) {

    switch(n) {
      case 0: client[i].pid = atoi(split); break;
      case 1: client[i].nowLife = atoi(split); break;
      case 2: client[i].betLife = atoi(split); break;
      case 3: client[i].showChance = atoi(split); break;      
      case 4: client[i].rank = atoi(split); break;
      case 5: printf("NULL 반환 혹은 ERROR!\n"); break;
    }
    split = strtok(NULL,"|@|");
    n++;
  }

  struct_buf[0] = '\0';    
}

void *t_waitClient(void *data) {
  pthread_mutex_lock(&mutex);

  while(pCount < 4) {

    if(-1 == listen(server_socket, 5)) {
      printf( "대기상태 모드 설정 실패\n");
      exit( 1);
    }
    net[pCount].num = pCount;
    net[pCount].addr_size  = sizeof(net[pCount].addr);
    net[pCount].socket  = accept(server_socket, (struct sockaddr*)&net[pCount].addr, &net[pCount].addr_size);

    if ( -1 == net[pCount].socket) {
      printf( "클라이언트 연결 수락 실패\n");
      exit( 1);
    }

    read(net[pCount].socket, struct_buf, BUFF_SIZE);
    printf("%d t_waitClient read\n",pCount);
    splitStruct(struct_buf, pCount);

    printf("Conntect Player : %d\n",client[pCount].pid);

    sprintf(buff_snd, "------------------------------\n|Thanks Enjoy My Game\n| Your User Unique ID = %d\n|Now Player Join %d\n| Wait Player %d more!\n-------------------------------\n",client[pCount].pid, pCount+1,3-pCount);

    pid = client[pCount].pid;
    write(net[pCount].socket, buff_snd, strlen(buff_snd)+1);


    kill(pid, SIGUSR1);
    printf("%d t_waitClient write!\n",pCount);

    pCount++;

  }
  pthread_mutex_unlock(&mutex);
  return (void *)ALL_PLAYER_READY;
}


void *t_t_revLife(void * data) {
  pthread_mutex_lock(&child_mutex);
  sock* n = data;
  int i = n->num;
  int tmp = client[i].nowLife;

  struct_buf[0] = '\0';

  read(net[i].socket, struct_buf, BUFF_SIZE);
  splitStruct(struct_buf,i); //일렬화를 변환해서  다시 구조체에 넣음

  pthread_mutex_unlock(&child_mutex);

}

void *t_t_result(void * data) {
  pthread_mutex_lock(&child_mutex);
  sock* n = data;
  int i = n->num;
  pid = client[i].pid;
  buff_snd[0] = '\0';
  switch(client[i].rank) {
    case 1:
      sprintf(buff_snd, "%s가장 높은 생명력을 배팅 하셨기 때문에 아무것도 획득하지 못했습니다.\n%s",resultGameString,readyNextTurnString);
      write(net[i].socket, buff_snd, strlen(buff_snd)+1);
      client[i].betLife = 0;        
      break;

    case 2:
      if(returnResult == DOUBLE_SECOND) {
        sprintf(buff_snd, "%s공동 2등이 두명입니다. 전체배팅금의 1/4의 생명력을 추가해드립니다.\n%s",resultGameString, readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].nowLife += revSumLife/4;
        client[i].betLife = 0;


      } else if(returnResult == NONE_SECOND) {
        sprintf(buff_snd, "%s가장 높은 생명력을 배팅 하셨기 때문에 아무것도 획득하지 못했습니다.\n%s",resultGameString,readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].betLife = 0;        

      } else if (returnResult == NOT_EXCEPTION) {
        sprintf(buff_snd, "%s축하합니다. 단독 2등입니다. 전체배팅금의 1/2의 생명력을 추가해드립니다.\n%s",resultGameString, readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].nowLife += revSumLife/2;
        client[i].betLife = 0;

      } else if(returnResult == DOUBLE_THIRD) {
        sprintf(buff_snd, "%s축하합니다. 단독 2등입니다. 전체배팅금의 1/2의 생명력을 추가해드립니다.\n%s",resultGameString, readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].nowLife += revSumLife/2;
        client[i].betLife = 0;
      }
      else {
        sprintf(buff_snd, "%s NOT NONEXCEPTION_ CASE 2 OUT ERROR. 단독 2등입니다. 전체배팅금의 1/2의 생명력을 추가해드립니다.\n%s",resultGameString, readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].nowLife += revSumLife/2;
        client[i].betLife = 0;
      }
      break;

    case 3:
      if(returnResult == DOUBLE_SECOND) {
        sprintf(buff_snd, "%s공동 2등이 두명입니다. 전체배팅금의 1/4의 생명력을 추가해드립니다.\n%s",resultGameString, readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].nowLife += revSumLife/4;
        client[i].betLife = 0;

      } else if(returnResult == DOUBLE_THIRD || returnResult == NOT_EXCEPTION) {
        sprintf(buff_snd, "%s3등입니다. 전체 사용자들의 생명력을 보여드립니다.\n%s 본인은 P%d 입니다.\n%s",resultGameString, all_status,i+1, readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].betLife = 0;

      } else if(returnResult == NONE_SECOND) {
        sprintf(buff_snd, "%s3등입니다. 전체 사용자들의 생명력을 보여드립니다.\n%s 본인은 P%d 입니다.\n%s",resultGameString, all_status,i+1, readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].betLife = 0;
        }
        else {
        sprintf(buff_snd, "%s NOT NONEXCEPTION_ CASE 2 OUT ERROR. 단독 2등입니다. 전체배팅금의 1/2의 생명력을 추가해드립니다.\n%s",resultGameString, readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].nowLife += revSumLife/2;
        client[i].betLife = 0;

      }
      break;

    case 4: 

      if(returnResult == DOUBLE_THIRD) {
        sprintf(buff_snd, "%s3등입니다. 전체 사용자들의 생명력을 보여드립니다.\n%s 본인은 P%d 입니다.\n%s",resultGameString, all_status,i+1, readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].betLife = 0;

      } else {
        sprintf(buff_snd, "%s4등입니다. 다음번엔 조금더 높은 생명력을 배팅해보세요.\n%s",resultGameString, readyNextTurnString);
        write(net[i].socket, buff_snd, strlen(buff_snd)+1);
        client[i].betLife = 0;
      }
      break;

    default:
      printf("Error!!!!!!! client.rank = %d\n",client[i].rank);
      break;
  }

  kill(pid, SIGUSR1); //Client 결과 출력
  printf("\n**** = %d client pid =%d, nowLife = %d, betLife = %d, showChance = %d, rank = %d\n",i,client[i].pid,client[i].nowLife,client[i].betLife,client[i].showChance,client[i].rank);
  printf("\n\n%s\n",buff_snd);

  sleep(1);
  s_struct = fun_sendData(i);
  write(net[i].socket, s_struct, strlen(s_struct)+1);
  kill(pid, SIGUSR1); // Client 구조체에 집어넣기  

  pthread_mutex_unlock(&child_mutex);
}

void *t_playGame(void *data) {
  int result;
  int i,j, k;
  int tmp = *((int *)data);
  int sendLife = 0;
  char turn[BUFF_SIZE];
  int tmpSort[4];

  pthread_t revThread[4];
  pthread_mutex_lock(&mutex);


  sprintf(turn,"%d",tmp);

  sprintf(resultGameString,"---------------Result of %s turn in game---------------\n",turn);
  sprintf(readyNextTurnString,"다음턴을 준비해주세요.\n");

  if(tmp < 11) {

    for (i=0 ; i< 4 ; i++) {
      pid = client[i].pid;
      write(net[i].socket, turn, strlen(turn)+1);
      kill(pid,SIGUSR1);
    }

    for (i=0 ; i< 4 ; i++) {
      if(-1 == pthread_create(&revThread[i], NULL, t_t_revLife, (void *)&net[i])) {
        printf("revThread %d create error!!\n",i);
        exit(1);
      }
    }

    for(i=0 ; i<4 ; i++) {
      pthread_join(revThread[i], (void **)&result);
    }  

    pthread_mutex_lock(&child_mutex);
    for(i=0 ; i<4 ; i++) {
      revSumLife = client[i].betLife + revSumLife;
      printf("---revLife = %d, Client %d bet Life = %d\n",revSumLife, i, client[i].betLife);
      client[i].rank = i+1; //1,2,3,4 init
      tmpSort[i] = client[i].betLife;
    }

    sprintf(all_status,"| P1: nowLife:%d, batLife:%d\n| P2: nowLife:%d, batLife:%d\n| P3: nowLife:%d, batLife:%d\n| P4: nowLife:%d, batLife:%d\n",client[0].nowLife, client[0].betLife, client[1].nowLife, client[1].betLife, client[2].nowLife, client[2].betLife,client[3].nowLife, client[3].betLife);


    //check rank
    for(i=0 ; i<sizeof(tmpSort)/sizeof(int)-1 ; i++) {
      for(j=i+1 ; j<4 ; j++) {
        if(tmpSort[i] < tmpSort[j]) {
          int temp = tmpSort[j];
          tmpSort[j] = tmpSort[i];
          tmpSort[i] = temp;
        }
      }
    }

    int overlap[4] = {1,1,1,1};  

    for(i = 0 ; i < 4 ; i++) { 
      if(tmpSort[i] == client[0].betLife && overlap[0]) {
        client[0].rank = i+1;
        overlap[0] = 0;
      } else if(tmpSort[i] == client[1].betLife && overlap[1]) {
        client[1].rank = i+1;
        overlap[1] = 0;
      } else if(tmpSort[i] == client[2].betLife && overlap[2]) {
        client[2].rank = i+1;
        overlap[2] = 0;
      } else if(tmpSort[i] == client[3].betLife && overlap[3]) {
        client[3].rank = i+1;
        overlap[3] = 0;
      }
    }

    for(i=0 ; i<4 ; i++) {
      printf("---------bet Money = %d, rank = %d--------\n",client[i].betLife,client[i].rank);
    }

    for(i=0 ; i<3 ; i++) {
      for(j=3 ; i<j ; j--) {
        if((client[i].rank == 2 && client[j].rank ==3) && (client[i].betLife == client[j].betLife)) { //1등이 1명 그리고 2등이 2명이며 배팅금액ㅇ ㅣ같을때
          returnResult = DOUBLE_SECOND;

        } else if ((client[i].rank ==3 && client[j].rank ==4) && (client[i].betLife == client[j].betLife)) { //3순위, 4순위 대 3순위가 두명일때
          returnResult = DOUBLE_THIRD;
        } else if((client[i].rank == 1 && client[j].rank ==2)&&(client[i].betLife == client[j].betLife )) { //1순위 2순위 대 2순위가 없을때
          returnResult = NONE_SECOND;
        }

      }
    }

    pthread_mutex_unlock(&child_mutex);
    printf("revSumLife = %d\n",revSumLife);

    for(i = 0 ; i<4 ; i++) {
      if(-1 == pthread_create(&revThread[i], NULL, t_t_result, (void *)&net[i])) {
        printf("revThread %d create error!!\n",i);
        exit(1);
      }
    }
    sleep(1);
    for(i=0 ; i<4 ; i++) {
      pthread_join(revThread[i], (void **)&result);
    }
    sleep(1);

    /*등수 재설정 */

    for (j= 0 ; j < 4 ; j++) {
      reRank[j] = client[j].nowLife;
    }


    //check rank
    for(j=0 ; j<sizeof(reRank)/sizeof(int)-1 ; j++) {
      for(k=j+1 ; k<4 ; k++) {
        if(reRank[j] < reRank[k]) {
          int temp = reRank[k];
          reRank[k] = reRank[j];
          reRank[j] = temp;
        }
      }
    }


    int overlap2[4] = {1,1,1,1};  

    for(j = 0 ; j < 4 ; j++) { 
      if(reRank[j] == client[0].nowLife && overlap2[0]) {
        client[0].rank = j+1;
        overlap2[0] = 0;
      } else if(reRank[j] == client[1].nowLife && overlap2[1]) {
        client[1].rank = j+1;
        overlap2[1] = 0;
      } else if(reRank[j] == client[2].nowLife && overlap2[2]) {
        client[2].rank = j+1;
        overlap2[2] = 0;
      } else if(reRank[j] == client[3].nowLife && overlap2[3]) {
        client[3].rank = j+1;
        overlap2[3] = 0;
      }
    }


    printf("\n-----------전체 진행상황----------\n");
    for(i = 0 ; i< 4 ; i++) {
      switch(client[i].rank) {
        case 1:
          printf("1등 Player%d : %d Life = %d\n",i,client[i].pid,client[i].nowLife); break;
        case 2:
          printf("2등 Player%d : %d Life = %d\n", i,client[i].pid, client[i].nowLife); break;
        case 3:
          printf("3등 Player%d : %d Life = %d\n", i,client[i].pid, client[i].nowLife); break;
        case 4:
          printf("4등 Player%d : %d Life = %d\n",i,client[i].pid,client[i].nowLife); break;
      }
    } //등수 재설정 종료

  } else { //턴이 11턴 째일때!

    for (j= 0 ; j < 4 ; j++) {
      reRank[j] = client[j].nowLife;
    }


    //check rank
    for(j=0 ; j<sizeof(reRank)/sizeof(int)-1 ; j++) {
      for(k=j+1 ; k<4 ; k++) {
        if(reRank[j] < reRank[k]) {
          int temp = reRank[k];
          reRank[k] = reRank[j];
          reRank[j] = temp;
        }
      }
    }


    int overlap2[4] = {1,1,1,1};  

    for(j = 0 ; j < 4 ; j++) { 
      if(reRank[j] == client[0].nowLife && overlap2[0]) {
        client[0].rank = j+1;
        overlap2[0] = 0;
      } else if(reRank[j] == client[1].nowLife && overlap2[1]) {
        client[1].rank = j+1;
        overlap2[1] = 0;
      } else if(reRank[j] == client[2].nowLife && overlap2[2]) {
        client[2].rank = j+1;
        overlap2[2] = 0;
      } else if(reRank[j] == client[3].nowLife && overlap2[3]) {
        client[3].rank = j+1;
        overlap2[3] = 0;
      }
    }


    buff_snd[0] = '\0';
    for(i=0 ; i <4 ; i++) {
      pid = client[i].pid;
      sprintf(buff_snd, "##################################\n#                                #\n#     게임이 종료되었습니다.     #\n#                                #\n#       당신은 %d등 입니다.       #\n#                                #\n#         고생하셨습니다.        #\n#                                #\n#                                #\n#                                #\n#      SangMyung University      #\n#    Open Source Linux Project   #\n#                                #\n#       made by giyeon.kim       #\n#                                #\n##################################\n",client[i].rank);

      write(net[i].socket, buff_snd, strlen(buff_snd)+1);
      kill(pid,SIGUSR1);
    }
    sleep(10);
    exit(0);
  }

  pthread_mutex_unlock(&mutex);
}

  int main( void) {
    pthread_t p_thread[10];

    struct sigaction mySig;

    int status;
    int result;
    int turn = 1;
    int turn_p;
    int m_status;

    mySig.sa_handler = rev_signal;
    sigemptyset(&mySig.sa_mask);
    mySig.sa_flags = 0;

    if(sigaction(SIGUSR1, &mySig, 0) == -1) {
      perror("can not catch SIGUSR1\n");
    }

    if ( 0 == access( FILE_SERVER, F_OK))
      unlink( FILE_SERVER);

    server_socket  = socket( PF_FILE, SOCK_STREAM, 0);

    if( -1 == server_socket) {
      perror("server socket 생성 실패\n");
      exit( 1);
    }

    memset( &server_addr, 0, sizeof( server_addr));
    server_addr.sun_family  = AF_UNIX;
    strcpy( server_addr.sun_path, FILE_SERVER);

    if( -1 == bind( server_socket, (struct sockaddr*)&server_addr, sizeof( server_addr) )) {
      perror("bind() 실행 에러\n");
      exit( 1);
    }

    if(-1 == pthread_create(&p_thread[0], NULL, t_waitClient, (void *)&pCount)) {
      perror("thread create error : \n");
      exit(0);
    }

    pthread_join(p_thread[0], (void **)&status); //wait Client 4

    if(status == ALL_PLAYER_READY)
      printf("%d Player is Ready Game Start\n",pCount);


    while(1) {

      turn_p = turn;

      if(-1 == pthread_create(&p_thread[1], NULL, t_playGame, (void *)&turn_p)) {
        perror("playGame Thread create error!!\n");
        exit(1);
      }

      pthread_join(p_thread[1], (void **)&result); //In game result;
      printf("게임 종료!\n");

      printf("join result = %d\n",result);
      //kill(pid, SIGUSR1);
      turn= turn+1;
      //printf("turn = %d\n",turn);
      m_status = pthread_mutex_destroy(&mutex);
      revSumLife = 0;
      returnResult = NOT_EXCEPTION;
      struct_buf[0] = '\0';
      buff_rcv[0] = '\0';

      //printf("mutex = %d\n",m_status);
      sleep(1);
    }

    return 0;      
  }
